CodeForces 115E Linear Kingdom Races(线段树 + DP)

Linear Kingdom Races
time limit per test
5 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

You are a car race organizer and would like to arrange some races in Linear Kingdom.

Linear Kingdom has n consecutive roads spanning from left to right. The roads are numbered from 1 to n from left to right, thus the roads follow in the order of their numbers' increasing. There will be several races that may be held on these roads. Each race will use aconsecutive subset of these roads. Also, each race will pay some amount of money to you if this race is held. No races overlap in time, so some roads can be used in several races.

Unfortunately, some of the roads are in a bad condition and they need repair. Each road has repair costs associated with it, you are required to pay this cost to repair the road. A race can only take place if all the roads used in the race are renovated. Your task is to repair such roads (possibly all or none) that will maximize your profit. Your profit is defined as the total money you get from the races that are held minus the total money you spent to repair the roads. Note that you may decide not to repair any road and gain zero profit.

Print the maximum profit you can gain.

Input

The first line contains two single-space separated integers, n and m (1 ≤ n, m ≤ 2·105), denoting the number of roads and the number of races, respectively.

Then n lines follow, each line will contain a single non-negative integer not exceeding 109 denoting the cost to repair a road. The costs are given in order from road 1 to road n.

Finally, m lines follow. Each line is single-space-separated triplets of integers. Each triplet will be given as lbub, and p(1 ≤ lb ≤ ub ≤ n, 1 ≤ p ≤ 109), which means that the race these three integers describe will use all the roads from lb to ub, inclusive, and if it's held you get p.

Output

Print a single integer denoting the maximum possible profit you can gain.

Please, do not use the %lld specificator to read or write 64-bit integers in C++. It is recommended to use cincout stream (also you may use %I64d specificator).

Sample test(s)
input
7 4
3
2
3
2
1
2
3
1 2 5
2 3 5
3 5 3
7 7 5
output
4
input
2 1
0
3
1 2 5
output
2
input
3 1
10
10
10
1 3 10
output
0

题意:有n条赛道,m场比赛,比赛需要占用若干条赛道,在举行比赛之前需要修理赛道,利润 = 举办比赛获利 - 修理赛道的费用,当然可以选择不举办某几场比赛,求最大利润。

先将所有比赛所要占用的赛道区间按右端从小到大排序,dp[i]表示前i场比赛可得的最大利润。若第i场比赛的赛道区间为[l, r],则影响利润的一定是l之前的赛道,所以第l - 1条及其之前的赛道都要加上第i场比赛的利润,若要修理第i条赛道,则第i - 1条及其之前的赛道都要减去修理第i条赛道所需的费用。

听学长讲可以用莫队算法做,不知道这个是不是跟莫队算法差不多。。。

#include <cstdio>
#include <iostream>
#include <algorithm>
#define ls node << 1
#define rs node << 1 | 1
#define lson l, mid, ls
#define rson mid + 1, r, rs
#define maxn 200005

using namespace std;

long long cost[maxn], maxx[maxn << 2], add[maxn << 2], dp[maxn];
int n, m;

struct Race{
    int l;
    int r;
    long long v;
}r[maxn];

bool cmp(Race x, Race y)
{
    return x.r < y.r;
}

void pushup(int l, int r, int node)
{
    maxx[node] = max(maxx[ls], maxx[rs]);
}

void pushdown(int node)
{
    if(add[node])
    {
        add[ls] += add[node];
        add[rs] += add[node];
        maxx[ls] += add[node];
        maxx[rs] += add[node];
        add[node] = 0;
    }
}

void build(int l, int r, int node)
{
    if(l == r)
    {
        maxx[node] = 0;
        add[node] = 0;
        return;
    }
    pushdown(node);
    int mid = (l + r) >> 1;
    build(lson);
    build(rson);
    pushup(l, r, node);
}

void update(int x, int y, long long v, int l, int r, int node)
{
    if(l >= x && r <= y)
    {
        add[node] += v;
        maxx[node] += v;
        return;
    }
    pushdown(node);
    int mid = (l + r) >> 1;
    if(x <= mid)
        update(x, y, v, lson);
    if(y > mid)
        update(x, y, v, rson);
    pushup(l, r, node);
}

int main()
{
    int cnt;
    while(scanf("%d%d", &n, &m) != EOF)
    {
        for(int i = 1; i <= n; i++)
            scanf("%d", &cost[i]);
        for(int i = 1; i <= m; i++)
            scanf("%d%d%lld", &r[i].l, &r[i].r, &r[i].v);
        sort(r + 1, r + m + 1, cmp);
        dp[0] = 0;
        build(0, n, 1);
        cnt = 1;
        for(int i = 1; i <= n; i++)
        {
            update(0, i - 1, -cost[i], 0, n, 1);
            while(r[cnt].r == i && cnt <= m)
            {
                update(0, r[cnt].l - 1, r[cnt].v, 0, n, 1);
                cnt++;
            }
            dp[i] = max(dp[i - 1], maxx[1]);
            update(i, i, dp[i], 0, n, 1);
        }
        printf("%lld\n",dp[n]);
    }
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
引用\[1\]中提到了一种树形动态规划的方法来解决CodeForces - 982C问题。在这个问题中,subtree指的是子连通块,而不是子树。为了使cnt_white - cnt_black尽可能大,可以使用两次树形动态规划来求解。第一次是自底向上的过程,维护一个dp数组,表示以每个节点为根的子树中的最大连通块。第二次是自顶向下的过程,处理自底向上过程中无法包含的树链所代表的子树。在第二次遍历中,需要维护一个sum变量,用于存储树链所代表的子树的贡献。根据ans\[u\]的正负,决定是否能对相邻的子节点做出贡献。如果ans\[u\]为正,则减去dp\[v\]就是树链所代表的子树的权值。最终,ans\[u\]代表包含节点u在内的子连通块的最大权值。\[1\] 问题: CodeForces - 982C 树形DP是什么问题?如何解决? 回答: CodeForces - 982C是一个树形动态规划问题。在这个问题中,需要求解子连通块的最大权值和,使得cnt_white - cnt_black尽可能大。解决这个问题的方法是使用两次树形动态规划。第一次是自底向上的过程,维护一个dp数组,表示以每个节点为根的子树中的最大连通块。第二次是自顶向下的过程,处理自底向上过程中无法包含的树链所代表的子树。在第二次遍历中,需要维护一个sum变量,用于存储树链所代表的子树的贡献。根据ans\[u\]的正负,决定是否能对相邻的子节点做出贡献。最终,ans\[u\]代表包含节点u在内的子连通块的最大权值。\[1\] #### 引用[.reference_title] - *1* *2* [CodeForces - 1324F Maximum White Subtree(树形dp)](https://blog.csdn.net/qq_45458915/article/details/104831678)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值